
#define DebugPrint	uart1SendByte
/* ======== USER SET DEFINES! ABSOLUTELY NECESSARY!  ====== */
#define 	FREQ_CPU				16000000
#define 	PWRKEY_PORT				PORTF
#define 	PWRKEY_PIN				0

#define 	STATUS_PORT				PINF
#define 	STATUS_PIN				1

#define 	SIM_PRESENCE_PORT		PINF
#define 	SIM_PRESENCE_PIN		2


//CINGULAR:		"wap.cingular"		"WAP@CINGULARGPRS.COM"		"CINGULAR1"
//T-MOBILE:		"m2m.t-mobile.com"	""							""

#define		CSTT_APN		"wap.cingular"
#define		CSTT_USER		"WAP@CINGULARGPRS.COM"
#define		CSTT_PASS		"CINGULAR1"

#define		CGDCONT_PDP		"IP"
#define		CGDCONT_APN		"wap.cingular"

#define 	TXT_MSG_CENTER	"+13123149810"
/* ======================================================== */


/* DEFINE ERROR CODES */
#define OK				48
#define CONNECT			49
#define NO_CARRIER		51
#define ERROR			52
#define DISCONNECT		56

/* DEFINE CUSTOM ERROR CODES */// BE SURE ALL ERROR CHECKS ARE INTs AND NOT CHARs
#define SIM_ERROR		300
#define POWER_ERROR		301
#define SETTINGS_ERROR	302
#define CONNECT_ERROR	303
#define IP_ERROR		304 
#define ATTACH_ERROR	305
#define CGDCONT_ERROR	306
#define CSTT_ERROR		307
#define CIPHEAD_ERROR	308
#define TIMEOUT_ERROR	309
#define	CMGF_ERROR		310
#define	CSCS_ERROR		311
#define	CSCA_ERROR		312
#define	CSMP_ERROR		313

#define TRUE	1
#define FALSE	0

#define HIGH	1
#define LOW		0

//define port functions; example: port_on( PORTD, 6);
#define port_on( port_letter, number )			port_letter |= (1<<number)
#define port_off( port_letter, number )			port_letter &= ~(1<<number)

#define port_is_on( port_letter, number )		( port_letter & (1<<number) )
#define port_is_off( port_letter, number )		!( port_letter & (1<<number) )

// TODO: Lots of defines here for pin definitions and the like
// function pointers to send and receive bytes
void (*SendByte)(unsigned char c); // SendByte	
int (*RawGetByte)(void);			  // GetByte
void (*FlushBuffer)(void);	//Flush UART Buffer

void DroneCell_Init( void (*putchar_func)(unsigned char c) , int (*getchar_func)(void) , void (*flush_buffer)(void) );
int GetByte(unsigned char seconds);

int CSTT(void);
int CGDCONT(void);
int CIICR(void);
int CIFSR(void);
int CIPHEAD(void);
int ConnectServer(char protocol[],char ip_address[],char port[]);
int Connect_Status(void);
void Toggle_PWRKEY(void);
int Read_STATUS(void);
int SIM_Presence(void);
int SIM_Status(void);
int DroneCell_InternetSettings(void);
int Start_Transmission(void);
int End_Transmission(void);
int Close_Socket(void);
int DroneCell_PowerOn(void);
int DroneCell_PowerOff(void);
int DroneCell_ConnectCalling(void);
int DroneCell_ConnectInternet(void);

int DroneCell_Call(char phone_number[]);
int CMGF(void);
int CSCS(void);
int CSCA(char msgcenter[]);
int CSMP(void);
int DroneCell_TextInit(void);
int Text_Transmit(char phone_number[]);
int DroneCell_Text( char phone_number[], char message[] );
