void Stop(void);
void TurnLeft(int speed);
void TurnRight(int speed);
void Reverse(void);
void MoveAngle(int angle);



void MoveAngle(int angle) {
	
	switch(angle) {
		
		case 0:  // LEFT
		   	SetE3_Right();
			pwmSetE3(10000);
	
			SetE4_Reverse();
			pwmSetE4(24250);

			SetH3_Forward();
			pwmSetH3(6554);

			SetH4_Reverse();
			pwmSetH4(0);
	
		   break;


		   case 90:
		   	SetE3_Right();
			pwmSetE3(0);
	
			SetE4_Forward();
			pwmSetE4(10000);

			SetH3_Forward();
			pwmSetH3(65535);

			SetH4_Forward();
			pwmSetH4(0);
	
		   break;


		   case 180:  // RIGHT
			SetE3_Left();
			pwmSetE3(10000);
	
			SetE4_Forward();
			pwmSetE4(24250);

			SetH3_Reverse();
			pwmSetH3(6554);

			SetH4_Forward();
			pwmSetH4(0);
	
		   break;

		
	
		   
		   case 270:
		   	SetE3_Right();
			pwmSetE3(0);
	
			SetE4_Reverse();
			pwmSetE4(65535);

			SetH3_Reverse();
			pwmSetH3(65535);

			SetH4_Forward();
			pwmSetH4(0);
	
		   break;	
		   		
		}
}
 
void MoveAngles(int angle) {
	switch(angle) {
	 	case 90:
		   	SetE3_Forward();
			pwmSetE3(39321);
	
			SetE4_Forward();
			pwmSetE4(55535);


			SetH3_Reverse();
			pwmSetH3(65535);

			SetH4_Forward();
			pwmSetH4(24250);
	
		   break;
			
			case 0:
		   	SetE3_Forward();
			pwmSetE3(6554/3);
	
			SetE4_Reverse();
			pwmSetE4(24248);

			SetH3_Forward();
			pwmSetH3(65535);

			SetH4_Reverse();
			pwmSetH4(24250/3);
	
		   break;

		   	case 180:
			SetE3_Reverse();
			pwmSetE3(65535);
	
			SetE4_Forward();
			pwmSetE4(24248);
		   break;
	}
}
void TurnLefts(int speed) {
			SetE3_Reverse();
			pwmSetE3(speed);
	
			SetE4_Reverse();
			pwmSetE4(speed);

			SetH3_Forward();
			pwmSetH3(speed);

			SetH4_Forward();
			pwmSetH4(speed);
}

void TurnRights(int speed) {
			SetE3_Forward();
			pwmSetE3(speed);
	
			SetE4_Forward();
			pwmSetE4(speed);

			SetH3_Reverse();
			pwmSetH3(speed);

			SetH4_Reverse();
			pwmSetH4(speed);
}


void TurnRight(int speed) {
			SetE3_Right();
			pwmSetE3(speed/5);
	
			SetE4_Reverse();
			pwmSetE4(speed);

			SetH3_Forward();
			pwmSetH3(speed);

			SetH4_Forward();
			pwmSetH4(speed);
}

void TurnLeft(int speed) {
			SetE3_Left();
			pwmSetE3(speed/5);
	
			SetE4_Forward();
			pwmSetE4(speed);

			SetH3_Reverse();
			pwmSetH3(speed);

			SetH4_Reverse();
			pwmSetH4(speed);
}

void Reverse(void) {
			SetE3_Reverse();
			pwmSetE3(29491/8);
	
			SetE4_Reverse();
			pwmSetE4(49151/8);

			SetH3_Reverse();
			pwmSetH3(29491/8);

			SetH4_Reverse();
			pwmSetH4(49151/8);
}


void SlowAngle(int angle) {
	
	switch(angle) {
		
		case 90:
		   	SetE3_Forward();
			pwmSetE3(39321/8);
	
			SetE4_Forward();
			pwmSetE4(65535/8);

			SetH3_Forward();
			pwmSetH3(39321/8);

			SetH4_Forward();
			pwmSetH4(65535/8);
	
		   break;

		case 0:
		   	SetE3_Forward();
			pwmSetE3(6554/3);
	
			SetE4_Reverse();
			pwmSetE4(24250/3);

			SetH3_Forward();
			pwmSetH3(6554/3);

			SetH4_Reverse();
			pwmSetH4(24250/3);
	
		   break;
		
		case 180:
			SetE3_Reverse();
			pwmSetE3(6554/3);
	
			SetE4_Forward();
			pwmSetE4(24250/3);

			SetH3_Reverse();
			pwmSetH3(6554/3);

			SetH4_Forward();
			pwmSetH4(24250/3);
	
		   break;

		case 270:
		   	SetE3_Reverse();
			pwmSetE3(39321/8);
	
			SetE4_Reverse();
			pwmSetE4(65535/8);

			SetH3_Reverse();
			pwmSetH3(39321/8);

			SetH4_Reverse();
			pwmSetH4(65535/8);
	
		   break;	
	
	
	}
}


void Stop(void) {
	pwmSetE3(0);
	pwmSetE4(0);
	pwmSetH3(0);
	pwmSetH4(0);
	PORT_ON(PORTC,6);
	PORT_ON(PORTC,5);

	PORT_ON(PORTA,4);
	PORT_ON(PORTA,5);

	PORT_ON(PORTC,2);
	PORT_ON(PORTC,3);

	PORT_ON(PORTC,0);
	PORT_ON(PORTC,1);
}
