// if function is uart(0) or if function is just uart() , need that for pointer
void FlushReceiveBuffer(void) {  // necessary to put here so that FlushBuffer pointer works
	uartFlushReceiveBuffer(0);
}

void control(void);

void control(void)	{

	DroneCell_Init( uart0SendByte , uart0GetByte , FlushReceiveBuffer ); 
	rprintfInit(DebugPrint); rprintf("DroneCell Initiated\n");
	
	int ErrorCode=0;
PowerOn:
	ErrorCode = DroneCell_PowerOn();
		if ( ErrorCode == OK) {
			rprintfInit(DebugPrint); rprintf("DroneCell Powered On\n");
		}
		else {
			rprintfInit(DebugPrint); rprintf("DroneCell Powered Off, Error Code: %d\n",ErrorCode);
		}

	ErrorCode = DroneCell_TextInit();
		if ( ErrorCode != OK) { 
			rprintfInit(DebugPrint); rprintf("Error: Cannot Initialize Texting,Error Code: %d \n",ErrorCode);
		}
		else {
			rprintfInit(DebugPrint); rprintf("Initalize Texting OK\n");
		}

ConnectCall:
	ErrorCode = DroneCell_ConnectCalling();
		if ( ErrorCode == OK) {
			rprintfInit(DebugPrint); rprintf("Connected to Calling\n");
		}
		else {
			rprintfInit(DebugPrint); rprintf("Connect Calling Error, Error Code: %d\n",ErrorCode);
		}
			
	/*	ErrorCode = DroneCell_Call("7722574501");
		if ( ErrorCode == OK) {
			rprintfInit(DebugPrint); rprintf("Connected to Phone\n");
		}
		else {
			rprintfInit(DebugPrint); rprintf("Connect Phone Error, Error Code: %d\n",ErrorCode);
		}
		*/
	 ErrorCode = DroneCell_Text("7722574501","Hello, this is an automated text message");
		if ( ErrorCode == OK) {
			rprintfInit(DebugPrint); rprintf("Sent Text Message\n");
		}
		else {
			rprintfInit(DebugPrint); rprintf("Text Message Error, Error Code: %d\n",ErrorCode);
		}

/*
ConnectInternet:
	ErrorCode = DroneCell_ConnectInternet();
		if ( ErrorCode == OK) {
			rprintfInit(DebugPrint); rprintf("Connected to Internet\n");
		}
		else {
			rprintfInit(DebugPrint); rprintf("Connect Internet Error, Error Code: %d\n",ErrorCode);
			delay_ms(2000);
			goto ConnectInternet;
		}
ConnectServer:

	ErrorCode = ConnectServer("TCP","123.456.789.0","1036"); // include COnnectStatus
		if ( ErrorCode != OK) { 
			rprintfInit(DebugPrint); rprintf("Error: Connect Server cannot connect,Error Code: %d \n",ErrorCode);
		}
		else {
			rprintfInit(DebugPrint); rprintf("Connect Server OK, Connected to Server\n");
		}
StartTransmission:
	ErrorCode = Start_Transmission();
	if ( ErrorCode  != OK ) {
		rprintfInit(uart1SendByte); rprintf("Error: Cannot start transmission\n");
		// TODO: Try Start again
	}
	else { // IF START TRANSMISSION WAS OK
		//------TRANSMISSION MESSAGE BELOW THIS LINE------
		
		rprintfInit(SendByte); rprintf("HELLO INTERNETZ\n");

		//------TRANSMISSION MESSAGE ABOVE THIS LINE------
		
		// End the Transmission
		ErrorCode = End_Transmission();
		if (ErrorCode != OK) { 
			rprintfInit(uart1SendByte); rprintf("Transmission Error, Error Code: %d\n",ErrorCode);
		}
		else {
			rprintfInit(uart1SendByte); rprintf("Transmission Successful\n");
		}
	} // end else for transmission
		rprintfInit(DebugPrint);
		
		int response[10];
		for (int i=0;i<6;++i) {  // get the rest of the bytes here
				response[i]=GetByte(10);
				if (response[i] == TIMEOUT_ERROR) 
					goto ConnectServer;
		} //end for
			
		rprintfInit(DebugPrint); rprintf("Data length = %c \n",response[4]);
			for (int i=0;i<(response[4]-48);++i) {  // get the rest of the bytes here
				response[i]=GetByte(10);
		} //end for
			for (int i=0;i<(response[4]-48);++i) {  // get the rest of the bytes here
				rprintf("%d = %c\n",i,response[i]);
		} //end for

	// Close the Socket and Terminate the Server Connection
	if (Close_Socket() != OK) {
		rprintfInit(DebugPrint); rprintf("Error: Cannot close socket\n");
	}
	else {
		rprintfInit(DebugPrint); rprintf("Close Socket successful\n");
	}
*/	
	ErrorCode = DroneCell_PowerOff();


} // end control sub
